// BugMeNot Plugin v. 0.1
// by SZMCZ
// szcmz@interia.pl (not a typo)
// 24.02.2014
// File: nig.js

// Sanitizer.
function sanitizer_nigs(txt){
	// We keep single special chars like <, >, " or ' - it may be part of password.
	// But we'll take special care about possible form-based XSS.
	// It'll be possible to "damage" form (if target script saves, for example, unsatanized
	// login in form in case of wrong password - rare case but...).
	// Example attack: foo"><script>[evilcode]</script
	// Example OK pass: O|<PassWorD
	// Example not-so-OK pass: O|<sometag>
	// Example we'll-better-remove-it pass: mycoolpassword">aaa<
	var map = txt.split('');
	var result = new String();
	var we_are_out = false;		// We can be outside of '<input>' value.
	var enclosed = false;		// Change behavior after first '<'.
	var rcur = 0;
	var rmax = map.length;
	while(rcur < rmax){
		if(map[rcur] == '<'){
			if(we_are_out || enclosed)
				result += ''; // technically nop
			else if(!enclosed)
				enclosed = true;
			else
				result += '<';
		}
		else if(map[rcur] == '>'){
			if(we_are_out || enclosed)
				result += '';
			else
				result += '';
		}
		else if(map[rcur] == '\''){
			if(!we_are_out){
				we_are_out = true;
				result += "'";
			}
		}
		else if(map[rcur] == '"'){
			if(!we_are_out){
				we_are_out = true;
				result += '"';
			}
		}
		else {
			result += map[rcur];
		}
		rcur++;
	}
	return result;
}

// Direct login.
self.port.on('direct-login', function(accsa){
	// Unpack gift.
	var login = accsa[0];
	var pass = accsa[1];
	// Report.
	self.port.emit('show-msg', accsa);
	// Try to find password input.
	var passin = document.getElementsByTagName('input');
	var foundpassin = 0;
	var cxp = 0;
	while(cxp < passin.length){
		if(foundpassin == 0 &&(passin[cxp].type == 'password' || passin[cxp].type == 'passwd' || passin[cxp].type == 'pass')){
			foundpassin++;
			var passid = cxp;
		}
		cxp++;
	}
	if(foundpassin == 0){
		alert('Error - form not found. Please contact developer.');
	}
	else {
		// Find text input.
		var cxl = 0;
		var cxpt = passid;
		while(cxpt >= 0){
			if(passin[cxpt].type == 'text' && cxl == 0){
				cxl = cxpt;
			}
			cxpt--;
		}
		// Fill form. Maybe.
		passin[passid].value = sanitizer_nigs(pass);
		passin[cxl].value = sanitizer_nigs(login);
		// Send. Maybe. Who knows.
		passin[cxl].form.submit();
		// Drop to shell. Good luck.
		self.port.emit('run-on');
	}
});


// The conf module.
self.port.on('conf', function(){
	var pass = document.getElementsByTagName('input');
	var cou = 0;
	var found = 0;
	while(cou < pass.length){
		if(pass[cou].type == 'password' || pass[cou].type == 'passwd' || pass[cou].type == 'pass'){
			found++;
		}
		cou++
	}
	if(found != 0){
		self.port.emit('conf-fail');
	}
	else {
		self.port.emit('conf-succ');
	}
});


// Bounce!
self.port.on('bonkers', function(ret){
	self.port.emit('conf-fail');
});
