// BugMeNot Plugin v. 0.1
// by SZMCZ
// szcmz@interia.pl (not a typo)
// 24.02.2014
// File: main.js

// Workers repository.
var rightclick = require('sdk/context-menu');
var self = require('sdk/self');
var tabs = require('sdk/tabs');
var remoter = require('sdk/page-worker');
var scouts = require('sdk/panel');


// Global state.
var gstate = 0;


// Scout.
var scout = scouts.Panel({
	width: 640,
	height: 350,
	contentURL: self.data.url('scout.html'),
	contentScriptFile: self.data.url('scout.js'),
	focus: true,
	onHide: function(){
		gstate = 0;
	}
});


// Fool!
function respawn_nig(acc, aid){
	var meharray = new Array();
	var nig = tabs.activeTab.attach({
		contentScriptFile: self.data.url('nig.js')
	});
	nig.port.on('show-msg', function(msg){
		scout.port.emit('show-msg', msg, 'nig');
	});
	nig.port.on('conf-fail', function(){
		if(aid >= acc[0].length){
			nig.destroy();
			scout.port.emit('stop-loader');
			gstate = 0;
			scout.port.emit('show-msg', 'Sorry, BugMeNot accounts doesn\'t work. Go ahead and register fake account!<br><br><br><small>Click anywhere on page to close this box.</small>', 'system');
		}
		else {
			meharray[0] = acc[0][aid];
			meharray[1] = acc[1][aid];
			aid++;
			nig.port.emit('direct-login', meharray);
		}
	});
	nig.port.on('conf-succ', function(){
		nig.destroy();	
		scout.port.emit('stop-loader');
		gstate = 0;
		scout.hide();
	});
	nig.port.on('run-on', function(){
		nig.tab.once('ready', function(){
			nig.destroy();
			if(gstate == 1){
				nig = respawn_nig(acc, aid);
				nig.port.emit('conf');
			}
		});
	});
	return nig;
}


// You might run on, for for a long time, run on, ducking and dodging.
function the_run_on(acc){
	var aid = 0;
	var nig = respawn_nig(acc, aid);
	nig.port.emit('bonkers');
}


// Parse accounts from BugMeNot.
function parse_bmn(domain){
	var rbmn = remoter.Page({
		contentScriptFile: self.data.url('bmn.js'),
		contentURL: 'http://bugmenot.com/view/' + domain
	});
	rbmn.port.once('parse-done', function(accs){
		rbmn.destroy();
		the_run_on(accs);
	});
	rbmn.port.once('error-zero', function(){
		scout.port.emit('stop-loader');
		scout.port.emit('show-msg', 'Sorry, this site is blocked on BugMeNot.<br><br><br><small>Click anywhere on page to close this box.</small>', 'system');
	});
	rbmn.port.emit('parse-it');
}


// The Run - first step.
function the_run(domain){
	scout.show();
	scout.port.emit('show-msg', 'Looking for accounts...', 'system');
	parse_bmn(domain);
}


// Direct login button.
var directlogin = rightclick.Item({
	label: 'Log in with BugMeNot',
	context: rightclick.SelectorContext('input'),
	contentScriptFile: self.data.url('direct_login.js'),
	onMessage: function(msg){
		gstate = 1;
		the_run(msg);
	}
});
